﻿
	function TestAddon:test_CopyTable()
		self:SetUp();
		local PB = {};
		local PAStore = {};
		PB["Data"] = {a="a", b="b", c={d="d", e="e"}};
		PAStore["Data"] = Utils:CopyTable(PB["Data"]);
		PB.Data.a = "Z";
		assertEquals(PAStore.Data.a, "a", "a");
		assertEquals(PAStore.Data.b, "b", "b");
		assertEquals(PAStore.Data.c.e, "e", "c.e");
		assertEquals(PAStore.Data.c.f, nil, "c.f");
		self:TearDown()
	end

	function TestAddon:test_OperatorCollection()
		self:SetUp();
		assertEquals(Utils.allowedOperators["="], true, "=");
		assertEquals(Utils.allowedOperators["!"], true, "!");
		assertEquals(Utils.allowedOperators[">"], true, ">");
		assertEquals(Utils.allowedOperators["<"], true, "<");
		assertEquals(Utils.allowedOperators[">="], true, ">=");
		assertEquals(Utils.allowedOperators["<="], true, "<=");
		assertEquals(Utils.allowedOperators["-"], true, "-");
		assertEquals(Utils.allowedOperators["a"], nil, "a");
		assertEquals(Utils.allowedOperators[""], nil, "blank");
		self:TearDown()
	end
	
	function TestAddon:test_Splitlines()
		self:SetUp();
		print();
		print("---------------------------");
		print("test_Splitlines");
		local text = "a=nu:param1=123; st:param2=werer\nb=2\nc=3";
		print(text);
		print("---------------------------");
		for k,v in string.gmatch(text, "([^=\n]+)=([^\n]+)") do
			print("key="..k.." val="..v);
		end

		self:TearDown()	
	end
