﻿package.path = "?;?.lua;..\\?;..\\?.lua";
--Unit testing framework
require("luacov")
require("luaunit")
-- WoW API mocking
require("WoWmock")
-- Addon specific Mocking code
require("UIMock")
--Addon code
require("Drshow")
require("Utils")
require("Dumper")


	function TestAddon:ClassSetUp()

		this = {};
		this.GetName = GetName;
		
	end

	function TestAddon:ClassTearDown()
		-- do nothing
	end

	function TestAddon:SetUp()
		self.Debug = false;
		WoWMock.AltKeyDown = false;
		WoWMock.ControlKeyDown = false;
		_Paladin_is_Ready = false;
		WoWMock.Output = "";
		WoWMock.Target = "target";
		GameTooltip:SetOwner(nil);
		UIParent ={};
		self.Output = "";
	end

	function TestAddon:TearDown()
		-- LuaUnit:SetVerbose(false);
	end
	
	function TestAddon:SetupFor(dump, locale)
		dofile("dumps/"..dump..".lua"); -- to get the locale
		if (locale) then
			DumpState.Locale = locale;
		end
		dofile("GlobalStrings/"..DumpState.Locale..".lua");
		dofile("../Drshow.lua");
		dofile("../Utils.lua");
		dofile("../Dumper.lua");
		dofile("dumps/"..dump..".lua"); -- to restore the settings
			
		--Call any start-up events here
		Drshow_OnLoad();
	end
	
	function TestAddon:UnitTestDebug(...)
		if (self.Debug) then
			print(...);		
		end
	end

	function TestAddon:UnitTestInfo(...)
		for k,v in pairs({...}) do
			self.Output = self.Output .. tostring(v) .. " ";
		end
		self.Output = self.Output .. "#";
	end	
	
--------------------TESTS START HERE ---------------------

	function TestAddon:test_UnitName()
		self:SetUp();
		self:SetupFor("SoloPaladin");
		local expectedName = "Smacker";
		local actualName, actualRealm = UnitName("player");
		assertEquals(actualName, expectedName, "Name");
		assertEquals(actualRealm, nil, "Realm");
		self:TearDown()
	end

	dofile("Test.Utils.lua");

LuaUnit.result.verbosity = 0;
LuaUnit:run();
