Utils = {
	allowedOperators = {
		["="] = true,
		[">"] = true,
		["<"] = true,
		["!"] = true,
		[">="] = true,
		["<="] = true,
		["-"] = true,
	};
}


function Utils:ReverseTable(t)
	if (type(t)~="table") then return nil; end
	local newTable = {};
	for k,v in pairs(t) do
		newTable[v] = k;
	end
	return newTable;
end

function Utils:CopyTable(t, lookup_table, original)
	if (type(t)=="table") then
		local copy;
		if (original==nil) then
			copy = {};
		else
			copy = original;
		end
		for i,v in pairs(t) do
			if (type(v)~="function") then
				if (type(v)~="table") then
					copy[i] = v;
				else
					lookup_table = lookup_table or {};
					lookup_table[t] = copy;
					if lookup_table[v] then
						copy[i] = lookup_table[v]; -- we already copied this table. reuse the copy.
					else
						copy[i] = self:CopyTable(v, lookup_table); -- not yet copied. copy it.
					end
				end
			end
		end
		return copy
	else
		return t;
	end
end

function Utils:MergeTables(desTable, sourceTable)
	if (not sourceTable or type(sourceTable)~="table") then
		return;
	end
	if (not desTable or type(desTable)~="table") then
		detTable = sourceTable;
		return;
	end
	
	for i,v in pairs(sourceTable) do
		if (type(v)~="function") then
			if (type(v)~="table") then
				desTable[i] = v;
			else
				self:MergeTables(desTable[i], v);
			end
		end
	end

end
	
